searchNodes=[{"ref":"Crawly.html","title":"Crawly","type":"module","doc":"Crawly is a fast high-level web crawling &amp; scraping framework for Elixir."},{"ref":"Crawly.html#fetch/3","title":"Crawly.fetch/3","type":"function","doc":"Fetches a given url. This function is mainly used for the spiders development when you need to get individual pages and parse them"},{"ref":"Crawly.API.Router.html","title":"Crawly.API.Router","type":"module","doc":"Crawly HTTP API. Allows to schedule/stop/get_stats of all running spiders."},{"ref":"Crawly.API.Router.html#call/2","title":"Crawly.API.Router.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"Crawly.API.Router.html#init/1","title":"Crawly.API.Router.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"Crawly.Utils.html","title":"Crawly.Utils","type":"module","doc":"Utility functions for Crawly"},{"ref":"Crawly.Utils.html#build_absolute_url/2","title":"Crawly.Utils.build_absolute_url/2","type":"function","doc":"A helper function which joins relative url with a base URL"},{"ref":"Crawly.Utils.html#build_absolute_urls/2","title":"Crawly.Utils.build_absolute_urls/2","type":"function","doc":"A helper function which joins relative url with a base URL for a list"},{"ref":"Crawly.Utils.html#pipe/3","title":"Crawly.Utils.pipe/3","type":"function","doc":"Pipeline/Middleware helper Executes a given list of pipelines on the given item, mimics filtermap behavior. Takes an item and state and passes it through a list of modules which implements a pipeline behavior, executing the pipeline&#39;s Crawly.Pipeline.run/3 function. The pipe function must either return a boolean (false), or an updated item. If false is returned by a pipeline, the item is dropped. It will not be processed by any descendant pipelines. In case of a pipeline crash, the pipeline will be skipped and the item will be passed on to descendant pipelines. The state variable is used to persist the information accross multiple items. Usage in Tests The Crawly.Utils.pipe/3 helper can be used in pipeline testing to simulate a set of middlewares/pipelines. Internally, this function is used for both middlewares and pipelines. Hence, you can use it for testing modules that implement the Crawly.Pipeline behaviour. For example, one can test that a given item is manipulated by a pipeline as so: item = %{my: &quot;item&quot;} state = %{} pipelines = [ MyCustomPipelineOrMiddleware ] {new_item, new_state} = Crawly.Utils.pipe(pipelines, item, state)"},{"ref":"Crawly.Utils.html#request_from_url/1","title":"Crawly.Utils.request_from_url/1","type":"function","doc":"A helper function which returns a Request structure for the given URL"},{"ref":"Crawly.Utils.html#requests_from_urls/1","title":"Crawly.Utils.requests_from_urls/1","type":"function","doc":"A helper function which converts a list of URLS into a requests list."},{"ref":"Crawly.ParsedItem.html","title":"Crawly.ParsedItem","type":"module","doc":"Defines the structure of spider&#39;s result"},{"ref":"Crawly.ParsedItem.html#t:item/0","title":"Crawly.ParsedItem.item/0","type":"type","doc":""},{"ref":"Crawly.ParsedItem.html#t:t/0","title":"Crawly.ParsedItem.t/0","type":"type","doc":""},{"ref":"Crawly.Request.html","title":"Crawly.Request","type":"module","doc":"Request wrapper Defines Crawly request structure."},{"ref":"Crawly.Request.html#t:header/0","title":"Crawly.Request.header/0","type":"type","doc":""},{"ref":"Crawly.Request.html#t:option/0","title":"Crawly.Request.option/0","type":"type","doc":""},{"ref":"Crawly.Request.html#t:t/0","title":"Crawly.Request.t/0","type":"type","doc":""},{"ref":"Crawly.Spider.html","title":"Crawly.Spider","type":"behaviour","doc":"A behavior module for implementing a Crawly Spider A Spider is a module which is responsible for defining: init/0 function, which must return a keyword list with start_urls list base_url/0 function responsible for filtering out requests not related to a given website parse_item/1 function which is responsible for parsing the downloaded request and converting it into items which can be stored and new requests which can be scheduled"},{"ref":"Crawly.Spider.html#c:base_url/0","title":"Crawly.Spider.base_url/0","type":"callback","doc":""},{"ref":"Crawly.Spider.html#c:init/0","title":"Crawly.Spider.init/0","type":"callback","doc":""},{"ref":"Crawly.Spider.html#c:parse_item/1","title":"Crawly.Spider.parse_item/1","type":"callback","doc":""},{"ref":"Crawly.Middlewares.DomainFilter.html","title":"Crawly.Middlewares.DomainFilter","type":"module","doc":"Filters out requests which are going outside of the crawled domain. The domain that is used to compare against the request url is obtained from the spider&#39;s c:Crawly.Spider.base_url callback. Does not accept any options. Tuple-based configuration optionswill be ignored. Example Declaration middlewares: [ Crawly.Middlewares.DomainFilter ]"},{"ref":"Crawly.Middlewares.DomainFilter.html#run/3","title":"Crawly.Middlewares.DomainFilter.run/3","type":"function","doc":"Callback implementation for Crawly.Pipeline.run/3."},{"ref":"Crawly.Middlewares.RobotsTxt.html","title":"Crawly.Middlewares.RobotsTxt","type":"module","doc":"Obey robots.txt A robots.txt file tells search engine crawlers which pages or files the crawler can or can&#39;t request from your site. This is used mainly to avoid overloading a site with requests! No options are required for this middleware. Any tuple-based configurations options passed will be ignored. Example Declaration middlewares: [ Crawly.Middlewares.RobotsTxt ]"},{"ref":"Crawly.Middlewares.RobotsTxt.html#run/3","title":"Crawly.Middlewares.RobotsTxt.run/3","type":"function","doc":"Callback implementation for Crawly.Pipeline.run/3."},{"ref":"Crawly.Middlewares.UniqueRequest.html","title":"Crawly.Middlewares.UniqueRequest","type":"module","doc":"Avoid scheduling requests for the same pages."},{"ref":"Crawly.Middlewares.UniqueRequest.html#run/2","title":"Crawly.Middlewares.UniqueRequest.run/2","type":"function","doc":""},{"ref":"Crawly.Middlewares.UserAgent.html","title":"Crawly.Middlewares.UserAgent","type":"module","doc":"Set/Rotate user agents for crawling. The user agents are read from :crawly, :user_agents sessions. The default value for the user agent is: Crawly Bot 1.0 Rotation is determined through Enum.random/1. Options :user_agents, optional. A list of user agent strings to rotate. Defaults to &quot;Crawly Bot 1.0&quot;. Example Declaration middlewares: [ {UserAgent, user_agents: [&quot;My Custom Bot] } ]"},{"ref":"Crawly.Middlewares.UserAgent.html#run/3","title":"Crawly.Middlewares.UserAgent.run/3","type":"function","doc":""},{"ref":"Crawly.Pipeline.html","title":"Crawly.Pipeline","type":"behaviour","doc":"A behavior module for implementing a pipeline module A pipeline is a module which takes a given item, and executes a run callback on a given item. A state argument is used to share common information accros multiple items. An opts argument is used to pass configuration to the pipeline through tuple-based declarations."},{"ref":"Crawly.Pipeline.html#c:run/2","title":"Crawly.Pipeline.run/2","type":"callback","doc":""},{"ref":"Crawly.Pipeline.html#c:run/3","title":"Crawly.Pipeline.run/3","type":"callback","doc":""},{"ref":"Crawly.Pipelines.CSVEncoder.html","title":"Crawly.Pipelines.CSVEncoder","type":"module","doc":"Encodes a given item (map) into CSV. Does not flatten nested maps. Options If no fields are given, the item is dropped from the pipeline. :fields, required: The fields to extract out from the scraped item. Falls back to the global config :item. Example Usage iex&gt; item = %{my: &quot;first&quot;, other: &quot;second&quot;, ignore: &quot;this_field&quot;} iex&gt; Crawly.Pipelines.CSVEncoder.run(item, %{}, fields: [:my, :other]) {&quot;first,second&quot;, %{}}"},{"ref":"Crawly.Pipelines.DuplicatesFilter.html","title":"Crawly.Pipelines.DuplicatesFilter","type":"module","doc":"Filters out duplicated items based on the provided item_id. Stores identifier values in state under the :duplicates_filter key. Options If item unique identifier is not provided, this pipeline does nothing. :item_id, required: Designates a field to be used to check for duplicates. Falls back to global config :item_id. Example Usage iex&gt; item = %{my: &quot;item&quot;} iex&gt; {_unchanged, new_state} = DuplicatesFilter.run(first, %{}, item_id: :my) # Rerunning the item through the pipeline will drop the item iex&gt; DuplicatesFilter.run(first, %{}, item_id: :id) {false, %{ duplicates_filter: %{&quot;item&quot; =&gt; true} }}"},{"ref":"Crawly.Pipelines.JSONEncoder.html","title":"Crawly.Pipelines.JSONEncoder","type":"module","doc":"Encodes a given item (map) into JSON No options are available for this pipeline. Example Declaration pipelines: [ Crawly.Pipelines.JSONEncoder ] Example Usage iex&gt; JSONEncoder.run(%{my: &quot;field&quot;}, %{}) {&quot;{&quot;my&quot;:&quot;field&quot;}&quot;, %{}}"},{"ref":"Crawly.Pipelines.Validate.html","title":"Crawly.Pipelines.Validate","type":"module","doc":"Ensure that scraped item contains a set of required fields. Options If the fields to check are not provided, the pipeline does nothing. :fields, required: The list of required fields. Fallsback to global config :item. Example Declaration pipelines: [ {Crawly.Pipelines.Validate, fields: [:id, :url, :date]} ] Example Usage # Drops the scraped item that does not have the required fields iex&gt; Validate.run(%{my: &quot;field&quot;}, %{}, fields: [:id]) {false, %{}}"},{"ref":"Crawly.Pipelines.WriteToFile.html","title":"Crawly.Pipelines.WriteToFile","type":"module","doc":"Stores a given item into Filesystem Pipeline Lifecycle: When run (by Crawly.Utils.pipe), creates a file descriptor if not already created. Performs the write operation File descriptor is reused by passing it through the pipeline state with :write_to_file_fd Note: File.close is not necessary due to the file descriptor being automatically closed upon the end of a the parent process. Refer to https://github.com/oltarasenko/crawly/pull/19#discussion_r350599526 for relevant discussion. Options In the absence of tuple-based options being passed, the pipeline will fallback onto the config of :crawly, Crawly.Pipelines.WriteToFile, for the :folder and :extension keys :folder, optional. The folder in which the file will be created. Defaults to system temp folder. :extension, optional. The file extension in which the file will be created with. Defaults to jl. Example Declaration pipelines: [ Crawly.Pipelines.JSONEncoder, {Crawly.Pipelines.WriteToFile, folder: &quot;/tmp&quot;, extension: &quot;csv&quot;} ] Example Output iex&gt; item = %{my: &quot;item&quot;} iex&gt; WriteToFile.run(item, %{}, folder: &quot;/tmp&quot;, extension: &quot;csv&quot;) { %{my: &quot;item&quot;} , %{write_to_file_fd: #PID&lt;0.123.0&gt;} }"},{"ref":"Crawly.DataStorage.html","title":"Crawly.DataStorage","type":"module","doc":"Data Storage, is a module responsible for storing crawled items. On the high level it&#39;s possible to represent the architecture of items storage this way: ┌──────────────────┐ │ │ ┌------------------┐ │ DataStorage &lt;─────────────┤ From crawlers1,2 │ │ │ └------------------┘ └─────────┬────────┘ │ │ │ │ ┌────────────▼─────────────────┐ │ │ │ │ │ │ ┌───────────▼──────────┐ ┌───────────▼──────────┐ │ DataStorageWorker1 │ │ DataStorageWorker2 │ │ (Crawler1) │ │ (Crawler2) │ └──────────────────────┘ └──────────────────────┘"},{"ref":"Crawly.DataStorage.html#child_spec/1","title":"Crawly.DataStorage.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.DataStorage.html#init/1","title":"Crawly.DataStorage.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.DataStorage.html#start_link/1","title":"Crawly.DataStorage.start_link/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.html#start_worker/1","title":"Crawly.DataStorage.start_worker/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.html#stats/1","title":"Crawly.DataStorage.stats/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.html#store/2","title":"Crawly.DataStorage.store/2","type":"function","doc":""},{"ref":"Crawly.DataStorage.Worker.html","title":"Crawly.DataStorage.Worker","type":"module","doc":"A worker process which stores items for individual spiders. All items are pre-processed by item_pipelines. All pipelines are using the state of this process for their internal needs (persistancy). The DataStorage.Worker will not write anything to a filesystem. Instead it would expect that pipelines are going to do that work."},{"ref":"Crawly.DataStorage.Worker.html#child_spec/1","title":"Crawly.DataStorage.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.DataStorage.Worker.html#init/1","title":"Crawly.DataStorage.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.DataStorage.Worker.html#start_link/1","title":"Crawly.DataStorage.Worker.start_link/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.Worker.html#stats/1","title":"Crawly.DataStorage.Worker.stats/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.Worker.html#store/2","title":"Crawly.DataStorage.Worker.store/2","type":"function","doc":""},{"ref":"Crawly.Engine.html","title":"Crawly.Engine","type":"module","doc":"Crawly Engine - process responsible for starting and stopping spiders. Stores all currently running spiders."},{"ref":"Crawly.Engine.html#child_spec/1","title":"Crawly.Engine.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.Engine.html#init/1","title":"Crawly.Engine.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.Engine.html#running_spiders/0","title":"Crawly.Engine.running_spiders/0","type":"function","doc":""},{"ref":"Crawly.Engine.html#start_link/0","title":"Crawly.Engine.start_link/0","type":"function","doc":""},{"ref":"Crawly.Engine.html#start_spider/1","title":"Crawly.Engine.start_spider/1","type":"function","doc":""},{"ref":"Crawly.Engine.html#stop_spider/1","title":"Crawly.Engine.stop_spider/1","type":"function","doc":""},{"ref":"Crawly.Engine.html#t:started_spiders/0","title":"Crawly.Engine.started_spiders/0","type":"type","doc":""},{"ref":"Crawly.Engine.html#t:t/0","title":"Crawly.Engine.t/0","type":"type","doc":""},{"ref":"Crawly.Manager.html","title":"Crawly.Manager","type":"module","doc":"Crawler manager module This module is responsible for spawning all processes related to a given Crawler. The manager spawns the following processes tree. ┌────────────────┐ ┌───────────────────┐ │ Crawly.Manager ├────────&gt; Crawly.ManagerSup │ └────────────────┘ └─────────┬─────────┘ │ | │ | ┌──────────────────────────┤ │ │ │ │ ┌────────▼───────┐ ┌─────────▼───────┐ │ Worker1 │ │ Worker2 │ └────────┬───────┘ └────────┬────────┘ │ │ │ │ │ │ │ │ ┌────────▼─────────┐ ┌──────────▼───────────┐ │Crawly.DataStorage│ │Crawly.RequestsStorage│ └──────────────────┘ └──────────────────────┘"},{"ref":"Crawly.Manager.html#child_spec/1","title":"Crawly.Manager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.Manager.html#init/1","title":"Crawly.Manager.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.Manager.html#start_link/1","title":"Crawly.Manager.start_link/1","type":"function","doc":""},{"ref":"Crawly.RequestsStorage.html","title":"Crawly.RequestsStorage","type":"module","doc":"Request storage, a module responsible for storing urls for crawling ┌──────────────────┐ │ │ ┌------------------┐ │ RequestsStorage &lt;─────────────┤ From crawlers1,2 │ │ │ └------------------┘ └─────────┬────────┘ │ │ │ │ ┌────────────▼─────────────────┐ │ │ │ │ │ │ ┌───────────▼──────────┐ ┌───────────▼──────────┐ │RequestsStorageWorker1│ │RequestsStorageWorker2│ │ (Crawler1) │ │ (Crawler2) │ └──────────────────────┘ └──────────────────────┘ All requests are going through one RequestsStorage process, which quickly finds the actual worker, which finally stores the request afterwords."},{"ref":"Crawly.RequestsStorage.html#child_spec/1","title":"Crawly.RequestsStorage.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.RequestsStorage.html#init/1","title":"Crawly.RequestsStorage.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.RequestsStorage.html#pop/1","title":"Crawly.RequestsStorage.pop/1","type":"function","doc":"Pop a request out of requests storage"},{"ref":"Crawly.RequestsStorage.html#start_link/1","title":"Crawly.RequestsStorage.start_link/1","type":"function","doc":""},{"ref":"Crawly.RequestsStorage.html#start_worker/1","title":"Crawly.RequestsStorage.start_worker/1","type":"function","doc":"Starts a worker for a given spider"},{"ref":"Crawly.RequestsStorage.html#stats/1","title":"Crawly.RequestsStorage.stats/1","type":"function","doc":"Get statistics from the requests storage"},{"ref":"Crawly.RequestsStorage.html#store/2","title":"Crawly.RequestsStorage.store/2","type":"function","doc":"Store request in related child worker"},{"ref":"Crawly.RequestsStorage.Worker.html","title":"Crawly.RequestsStorage.Worker","type":"module","doc":"Requests Storage, is a module responsible for storing requests for a given spider. Automatically filters out already seen requests (uses fingerprints approach to detect already visited pages). Pipes all requests through a list of middlewares, which do pre-processing of all requests before storing them"},{"ref":"Crawly.RequestsStorage.Worker.html#child_spec/1","title":"Crawly.RequestsStorage.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.RequestsStorage.Worker.html#init/1","title":"Crawly.RequestsStorage.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.RequestsStorage.Worker.html#pop/1","title":"Crawly.RequestsStorage.Worker.pop/1","type":"function","doc":"Pop a request out of requests storage"},{"ref":"Crawly.RequestsStorage.Worker.html#start_link/1","title":"Crawly.RequestsStorage.Worker.start_link/1","type":"function","doc":""},{"ref":"Crawly.RequestsStorage.Worker.html#stats/1","title":"Crawly.RequestsStorage.Worker.stats/1","type":"function","doc":"Get statistics from the requests storage"},{"ref":"Crawly.RequestsStorage.Worker.html#store/2","title":"Crawly.RequestsStorage.Worker.store/2","type":"function","doc":"Store individual request request"},{"ref":"Crawly.Worker.html","title":"Crawly.Worker","type":"module","doc":"A worker process responsible for the actual work (fetching requests, processing responces)"},{"ref":"Crawly.Worker.html#child_spec/1","title":"Crawly.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.Worker.html#init/1","title":"Crawly.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.Worker.html#start_link/1","title":"Crawly.Worker.start_link/1","type":"function","doc":""},{"ref":"introduction.html","title":"Crawly","type":"extras","doc":"Crawly Crawly is a web crawling framework, written in Elixir."},{"ref":"introduction.html#installation","title":"Crawly - Installation","type":"extras","doc":"Crawly requires Elixir v1.7 or higher. Add Crawly to you mix.exs file def deps do [{:crawly, &quot;~&gt; 0.7.0&quot;}] end Update your dependencies with mix deps.get"},{"ref":"introduction.html#walk-through-of-an-example-spider","title":"Crawly - Walk-through of an example spider","type":"extras","doc":"In order to show you what Crawly brings to the table, we’ll walk you through an example of a Crawly spider using the simplest way to run a spider. Here’s the code for a spider that scrapes blog posts from the Erlang Solutions blog: https://www.erlang-solutions.com/blog.html, following the pagination: defmodule Esl do @behaviour Crawly.Spider @impl Crawly.Spider def base_url(), do: &quot;https://www.erlang-solutions.com&quot; def init() do [ start_urls: [&quot;https://www.erlang-solutions.com/blog.html&quot;] ] end @impl Crawly.Spider def parse_item(response) do # Getting new urls to follow urls = response.body |&gt; Floki.find(&quot;a.more&quot;) |&gt; Floki.attribute(&quot;href&quot;) |&gt; Enum.uniq() # Convert URLs into requests requests = Enum.map(urls, fn url -&gt; url |&gt; build_absolute_url(response.request_url) |&gt; Crawly.Utils.request_from_url() end) # Extract item from a page, e.g. # https://www.erlang-solutions.com/blog/introducing-telemetry.html title = response.body |&gt; Floki.find(&quot;article.blog_post h1:first-child&quot;) |&gt; Floki.text() author = response.body |&gt; Floki.find(&quot;article.blog_post p.subheading&quot;) |&gt; Floki.text(deep: false, sep: &quot;&quot;) |&gt; String.trim_leading() |&gt; String.trim_trailing() time = response.body |&gt; Floki.find(&quot;article.blog_post p.subheading time&quot;) |&gt; Floki.text() url = response.request_url %Crawly.ParsedItem{ :requests =&gt; requests, :items =&gt; [%{title: title, author: author, time: time, url: url}] } end def build_absolute_url(url, request_url) do URI.merge(request_url, url) |&gt; to_string() end end Put this code into your project and run it using the Crawly REST API: curl -v localhost:4001/spiders/Esl/schedule When it finishes you will get the ESL.jl file stored on your filesystem containing the following information about blog posts: {&quot;url&quot;:&quot;https://www.erlang-solutions.com/blog/erlang-trace-files-in-wireshark.html&quot;,&quot;title&quot;:&quot;Erlang trace files in Wireshark&quot;,&quot;time&quot;:&quot;2018-06-07&quot;,&quot;author&quot;:&quot;by Magnus Henoch&quot;} {&quot;url&quot;:&quot;https://www.erlang-solutions.com/blog/railway-oriented-development-with-erlang.html&quot;,&quot;title&quot;:&quot;Railway oriented development with Erlang&quot;,&quot;time&quot;:&quot;2018-06-13&quot;,&quot;author&quot;:&quot;by Oleg Tarasenko&quot;} {&quot;url&quot;:&quot;https://www.erlang-solutions.com/blog/scaling-reliably-during-the-world-s-biggest-sports-events.html&quot;,&quot;title&quot;:&quot;Scaling reliably during the World’s biggest sports events&quot;,&quot;time&quot;:&quot;2018-06-21&quot;,&quot;author&quot;:&quot;by Erlang Solutions&quot;} {&quot;url&quot;:&quot;https://www.erlang-solutions.com/blog/escalus-4-0-0-faster-and-more-extensive-xmpp-testing.html&quot;,&quot;title&quot;:&quot;Escalus 4.0.0: faster and more extensive XMPP testing&quot;,&quot;time&quot;:&quot;2018-05-22&quot;,&quot;author&quot;:&quot;by Konrad Zemek&quot;} {&quot;url&quot;:&quot;https://www.erlang-solutions.com/blog/mongooseim-3-1-inbox-got-better-testing-got-easier.html&quot;,&quot;title&quot;:&quot;MongooseIM 3.1 - Inbox got better, testing got easier&quot;,&quot;time&quot;:&quot;2018-07-25&quot;,&quot;author&quot;:&quot;by Piotr Nosek&quot;} ...."},{"ref":"introduction.html#what-just-happened","title":"Crawly - What just happened?","type":"extras","doc":"When you ran the curl command: curl -v localhost:4001/spiders/Esl/schedule Crawly runs a spider ESL, Crawly looked for a Spider definition inside it and ran it through its crawler engine. The crawl started by making requests to the URLs defined in the start_urls attribute of the spider&#39;s init, and called the default callback method parse_item, passing the response object as an argument. In the parse callback, we loop: Look through all pagination the elements using a Floki Selector and extract absolute URLs to follow. URLS are converted into Requests, using Crawly.Utils.request_from_url() function Extract item(s) (items are defined in separate modules, and this part will be covered later on) Return a Crawly.ParsedItem structure which is containing new requests to follow and items extracted from the given page, all following requests are going to be processed by the same parse_item function. Crawly is fully asynchronous. Once the requests are scheduled, they are picked up by separate workers and are executed in parallel. This also means that other requests can keep going even if some request fails or an error happens while handling it. While this enables you to do very fast crawls (sending multiple concurrent requests at the same time, in a fault-tolerant way) Crawly also gives you control over the politeness of the crawl through a few settings. You can do things like setting a download delay between each request, limiting the amount of concurrent requests per domain or respecting robots.txt rules This is using JSON export to generate the JSON lines file, but you can easily extend it to change the export format (XML or CSV, for example)."},{"ref":"introduction.html#what-else","title":"Crawly - What else?","type":"extras","doc":"You’ve seen how to extract and store items from a website using Crawly, but this is just a basic example. Crawly provides a lot of powerful features for making scraping easy and efficient, such as: Flexible request spoofing (for example user-agents rotation, cookies management (this feature is planned.)) Items validation, using pipelines approach. Filtering already seen requests and items. Filter out all requests which targeted at other domains. Robots.txt enforcement. Concurrency control. HTTP API for controlling crawlers. Interactive console, which allows you to create and debug spiders more easily."},{"ref":"quickstart.html","title":"Quickstart","type":"extras","doc":"Quickstart Goals: Scrape the Erlang Solutions blog for articles, and scrape the article titles. Perform pagination to see more blog posts. Add Crawly as a dependencies: # mix.exs defp deps do [ {:crawly, &quot;~&gt; 0.7.0&quot;} ] end Fetch dependencies: $ mix deps.get Create a spider # lib/crawly_example/esl_spider.ex defmodule EslSpider do @behaviour Crawly.Spider alias Crawly.Utils @impl Crawly.Spider def base_url(), do: &quot;https://www.erlang-solutions.com&quot; @impl Crawly.Spider def init(), do: [start_urls: [&quot;https://www.erlang-solutions.com/blog.html&quot;]] @impl Crawly.Spider def parse_item(response) do hrefs = response.body |&gt; Floki.find(&quot;a.more&quot;) |&gt; Floki.attribute(&quot;href&quot;) requests = Utils.build_absolute_urls(hrefs, base_url()) |&gt; Utils.requests_from_urls() title = response.body |&gt; Floki.find(&quot;article.blog_post h1&quot;) |&gt; Floki.text() %{ :requests =&gt; requests, :items =&gt; [%{title: title, url: response.request_url}] } end end Configure Crawly By default, Crawly does not require any configuration. But obviously you will need a configuration for fine tuning the crawls: # in config.exs config :crawly, closespider_timeout: 10, concurrent_requests_per_domain: 8, follow_redirects: true, closespider_itemcount: 1000, middlewares: [ Crawly.Middlewares.DomainFilter, Crawly.Middlewares.UniqueRequest, Crawly.Middlewares.UserAgent ], pipelines: [ {Crawly.Pipelines.Validate, fields: [:title, :url]}, {Crawly.Pipelines.DuplicatesFilter, item_id: :title }, {Crawly.Pipelines.CSVEncoder, fields: [:title, :url}], {Crawly.Pipelines.WriteToFile, extension: &quot;csv&quot;, folder: &quot;/tmp&quot; } ] Start the Crawl: $ iex -S mix iex(1)&gt; Crawly.Engine.start_spider(EslSpider) Results can be seen with: $ cat /tmp/EslSpider.csv"},{"ref":"tutorial.html","title":"Tutorial","type":"extras","doc":"Tutorial In this tutorial, we’ll assume that Elixir is already installed on your system. If that’s not the case, see Installation guide: https://elixir-lang.org/install.html We are going to scrape https://www.homebase.co.uk, a website that contains products of different types. This tutorial will walk you through these tasks: Creating a new Crawly project. Writing a spider to crawl a site and extract data. Exporting the scraped data. Crawly is written in Elixir. If you’re new to the language you might want to start by getting an idea of what the language is like, to get the most out of Crawly. If you’re already familiar with other languages, and want to learn Elixir quickly, the Elixir website https://elixir-lang.org/learning.html is a good resource."},{"ref":"tutorial.html#creating-a-project","title":"Tutorial - Creating a project","type":"extras","doc":"Before you start crawling, you will have to set up a new Crawly project. Enter a directory where you’d like to store your code and run: mix new tutorial --sup This will create a tutorial directory with the following contents: tutorial ├── README.md ├── config │   └── config.exs ├── lib │   ├── tutorial │   │   └── application.ex │   └── tutorial.ex ├── mix.exs └── test ├── test_helper.exs └── tutorial_test.exs Switch to the project folder: cd ./tutorial and update the mix.exs file with the following code: def deps do [{:crawly, &quot;~&gt; 0.7.0&quot;}] end Now run mix deps.get"},{"ref":"tutorial.html#our-first-spider","title":"Tutorial - Our first spider","type":"extras","doc":"Spiders are behaviours which you defined and that Crawly uses to extract information from a given website. The spider must implement the spider behaviour (it&#39;s required to implement parse_item/1, init/0, base_url/0 callbacks) This is the code for our first spider. Save it in a file name homebase.ex under the lib/tutorial/spiders directory of your project. defmodule Homebase do @behaviour Crawly.Spider @impl Crawly.Spider def base_url(), do: &quot;https://www.homebase.co.uk&quot; @impl Crawly.Spider def init() do [ start_urls: [ &quot;https://www.homebase.co.uk/our-range/tools&quot; ] ] end @impl Crawly.Spider def parse_item(_response) do %Crawly.ParsedItem{:items =&gt; [], :requests =&gt; []} end end As you can see, our Spider implements the Spider behaviour and defines some functions: base_url: method which returns base_urls for the given Spider, used in order to filter out all irrelevant requests. In our case we don&#39;t want our crawler to follow links going to social media sites and other partner sites (which are not related to the homebase website themselves) init(): must return a KW list which contains start_urls list which Crawler will begin to crawl from. Subsequent requests will be generated from these initial urls. parse_item(): function which will be called to handle response downloaded by Crawly. It must return the Crawly.ParsedItem structure."},{"ref":"tutorial.html#how-to-run-our-spider","title":"Tutorial - How to run our spider","type":"extras","doc":"To put our spider to work, go to the project’s top level directory and run: iex -S mix - It will start the Elixir application which we have created, and will open interactive console Execute the following command in the opened Elixir console: Crawly.Engine.start_spider(Homebase) You will get an output similar to this: iex(2)&gt; Crawly.Engine.start_spider(Homebase) 15:03:47.134 [info] Starting the manager for Elixir.Homebase =PROGRESS REPORT==== 23-May-2019::15:03:47 === supervisor: {&lt;0.415.0&gt;,&#39;Elixir.Crawly.ManagerSup&#39;} started: [{pid,&lt;0.416.0&gt;}, {id,&#39;Elixir.Homebase&#39;}, {mfargs, {&#39;Elixir.DynamicSupervisor&#39;,start_link, [[{strategy,one_for_one}, {name,&#39;Elixir.Homebase&#39;}]]}}, {restart_type,permanent}, {shutdown,infinity}, {child_type,supervisor}] 15:03:47.137 [debug] Starting requests storage worker for Elixir.Homebase.. 15:04:06.698 [debug] No work, increase backoff to 2400 15:04:06.699 [debug] No work, increase backoff to 4800 15:04:06.699 [debug] No work, increase backoff to 9600 15:04:07.973 [debug] No work, increase backoff to 19200 15:04:17.787 [info] Stopping Homebase, itemcount timeout achieved"},{"ref":"tutorial.html#what-just-happened-under-the-hood","title":"Tutorial - What just happened under the hood?","type":"extras","doc":"Crawly schedules the Request objects returned by the init function of the Spider. Upon receiving a response for each one, it instantiates Response objects and calls the callback function associated with the request passing the response as argument. In our case we have not defined any data to be returned by the parse_item callback. And in our the Crawly worker processes (processes responsible for downloading requests) did not have work to do. And in the cases like that, they will slow down progressively, until the switch off (which happened because the Spider was not extracting items fast enough). And if you&#39;re wondering how to extract the data from the response, please hold on. We&#39;re going to cover it in the next section."},{"ref":"tutorial.html#extracting-data","title":"Tutorial - Extracting data","type":"extras","doc":"The best way to learn how to extract data with Crawly is trying the selectors in Crawly shell. Start the Elixir shell using iex -S mix command Now you can fetch a given HTTP response using the following command: {:ok, response} = Crawly.fetch(&quot;https://www.homebase.co.uk/our-range/tools&quot;) You will see something like: {:ok, %HTTPoison.Response{ body: &quot;[response body here...]&quot; headers: [ {&quot;Date&quot;, &quot;Fri, 24 May 2019 02:37:26 GMT&quot;}, {&quot;Content-Type&quot;, &quot;text/html; charset=utf-8&quot;}, {&quot;Transfer-Encoding&quot;, &quot;chunked&quot;}, {&quot;Connection&quot;, &quot;keep-alive&quot;}, {&quot;Cache-Control&quot;, &quot;no-cache, no-store&quot;}, {&quot;Pragma&quot;, &quot;no-cache&quot;}, {&quot;Expires&quot;, &quot;-1&quot;}, {&quot;Vary&quot;, &quot;Accept-Encoding&quot;}, {&quot;Set-Cookie&quot;, &quot;Bunnings.Device=default; path=/&quot;}, {&quot;Set-Cookie&quot;, &quot;ASP.NET_SessionId=bcb2deqlapednir0lysulo1h; path=/; HttpOnly&quot;}, {&quot;Set-Cookie&quot;, &quot;Bunnings.Device=default; path=/&quot;}, {&quot;Set-Cookie&quot;, &quot;ASP.NET_SessionId=bcb2deqlapednir0lysulo1h; path=/; HttpOnly&quot;}, {&quot;Set-Cookie&quot;, &quot;Bunnings.UserType=RetailUser; path=/&quot;}, ...., {&quot;Set-Cookie&quot;, &quot;__AntiXsrfToken=fd198cd78d1b4826ba00c24c3af1ec56; path=/; HttpOnly&quot;}, {&quot;Server&quot;, &quot;cloudflare&quot;}, {&quot;CF-RAY&quot;, &quot;4dbbe33fae7e8b20-KBP&quot;} ], request: %HTTPoison.Request{ body: &quot;&quot;, headers: [], method: :get, options: [], params: %{}, url: &quot;https://www.homebase.co.uk/our-range/tools&quot; }, request_url: &quot;https://www.homebase.co.uk/our-range/tools&quot;, status_code: 200 }} Using the shell, you can try selecting elements using Floki with the response. Lets say that we want to extract all product categories links from the page above: response.body |&gt; Floki.find(&quot;div.product-list-footer a&quot;) |&gt; Floki.attribute(&quot;href&quot;) &quot;/our-range/tools/power-tools/drills&quot;, &quot;/our-range/tools/power-tools/saws&quot;, &quot;/our-range/tools/power-tools/sanders&quot;, &quot;/our-range/tools/power-tools/electric-screwdrivers&quot;, &quot;/our-range/tools/power-tools/tools-accessories&quot;, &quot;/our-range/tools/power-tools/routers-and-planers&quot;, &quot;/our-range/tools/power-tools/multi-tools&quot;, &quot;/our-range/tools/power-tools/impact-drivers-and-wrenches&quot;, &quot;/our-range/tools/power-tools/air-compressors&quot;, &quot;/our-range/tools/power-tools/angle-grinders&quot;, &quot;/our-range/tools/power-tools/heat-guns&quot;, &quot;/our-range/tools/power-tools/heavy-duty-construction-tools&quot;, &quot;/our-range/tools/power-tools/welding&quot; ...] The result of running the command above is a list of elements which contain href attribute of links selected with a.category-block-heading__title css selector. These URLs will be used in order to feed Crawly with requests to follow. In order to find the proper CSS selectors to use, you might find useful opening the target page from the shell in your web browser. You can use your browser developer tools to inspect the HTML and come up with a selector. Now let&#39;s navigate to one of the Homebase product pages and extract data from it. {:ok, response} = Crawly.fetch(&quot;https://www.homebase.co.uk/4-tier-heavy-duty-shelving-unit_p375180&quot;) Extract the title with: response.body |&gt; Floki.find(&quot;.page-title h1&quot;) |&gt; Floki.text() &quot;4 Tier Heavy Duty Shelving Unit&quot; Extract the SKU with: response.body |&gt; Floki.find(&quot;.product-header-heading span&quot;) |&gt; Floki.text &quot;SKU: 375180&quot; Extract the price with: response.body |&gt; Floki.find(&quot;.price-value [itemprop=priceCurrency]&quot;) |&gt; Floki.text &quot;£75&quot;"},{"ref":"tutorial.html#extracting-data-in-our-spider","title":"Tutorial - Extracting data in our spider","type":"extras","doc":"Let’s get back to our spider. Until now, it doesn’t extract any data, just makes an empty run. Let’s integrate the extraction logic above into our spider. defmodule Homebase do @behaviour Crawly.Spider @impl Crawly.Spider def base_url(), do: &quot;https://www.homebase.co.uk&quot; @impl Crawly.Spider def init() do [ start_urls: [ &quot;https://www.homebase.co.uk/our-range/tools&quot; ] ] end @impl Crawly.Spider def parse_item(response) do # Extract product category URLs product_categories = response.body |&gt; Floki.find(&quot;div.product-list-footer a&quot;) |&gt; Floki.attribute(&quot;href&quot;) # Extract individual product page URLs product_pages = response.body |&gt; Floki.find(&quot;a.product-tile &quot;) |&gt; Floki.attribute(&quot;href&quot;) urls = product_pages ++ product_categories # Convert URLs into Requests requests = urls |&gt; Enum.uniq() |&gt; Enum.map(&amp;build_absolute_url/1) |&gt; Enum.map(&amp;Crawly.Utils.request_from_url/1) # Create item (for pages where items exists) item = %{ title: response.body |&gt; Floki.find(&quot;.page-title h1&quot;) |&gt; Floki.text(), sku: response.body |&gt; Floki.find(&quot;.product-header-heading span&quot;) |&gt; Floki.text(), price: response.body |&gt; Floki.find(&quot;.price-value [itemprop=priceCurrency]&quot;) |&gt; Floki.text() } %Crawly.ParsedItem{:items =&gt; [item], :requests =&gt; requests} end defp build_absolute_url(url), do: URI.merge(base_url(), url) |&gt; to_string() end If you run this spider, it will output the extracted data with the log: 17:23:42.536 [debug] Scraped %{price: &quot;£3.99&quot;, sku: &quot;SKU: 486386&quot;, title: &quot;Bon Safety EN20471 Hi viz Yellow Vest, size XL&quot;} 17:23:43.432 [debug] Scraped %{price: &quot;£3.99&quot;, sku: &quot;SKU: 486384&quot;, title: &quot;Bon Safety EN20471 Hi viz Yellow Vest, size L&quot;} 17:23:42.389 [debug] Scraped %{price: &quot;£5.25&quot;, sku: &quot;SKU: 414464&quot;, title: &quot;Toughbuilt 24in Wall Organizer&quot;} Also you will see messages like: 17:23:42.435 [debug] Dropping request: https://www.homebase.co.uk/bon-safety-rain-de-pro-superlight-weight-rainsuit-xxl_p275608, as it&#39;s already processed 17:23:42.435 [debug] Dropping request: https://www.homebase.co.uk/bon-safety-rain-de-pro-superlight-weight-rainsuit-l_p275605, as it&#39;s already processed 17:23:42.435 [debug] Dropping request: https://www.homebase.co.uk/bon-safety-rain-de-pro-superlight-weight-rainsuit-xl_p275607, as it&#39;s already processed That&#39;s because Crawly filters out requests which it has already visited during the current run."},{"ref":"tutorial.html#where-the-data-is-stored-afterwords","title":"Tutorial - Where the data is stored afterwords?","type":"extras","doc":"You might wonder where is the resulting data is located by default? Well the default location of the scraped data is under the /tmp folder. This can be controlled by the base_store_path variable in the Crawly configuration (:crawly, :base_store_path)."},{"ref":"tutorial.html#next-steps","title":"Tutorial - Next steps","type":"extras","doc":"This tutorial covered only the basics of Crawly, but there’s a lot of other features not mentioned here. You can continue from the section Basic concepts to know more about the basic Crawly features."},{"ref":"basic_concepts.html","title":"Basic Concepts","type":"extras","doc":"Basic Concepts"},{"ref":"basic_concepts.html#spiders","title":"Basic Concepts - Spiders","type":"extras","doc":"Spiders are modules which define how a certain site (or a group of sites) will be scraped, including how to perform the crawl (i.e. follow links) and how to extract structured data from their pages (i.e. scraping items). In other words, Spiders are the place where you define the custom behaviour for crawling and parsing pages for a particular site. For spiders, the scraping cycle goes through something like this: You start by generating the initial Requests to crawl the first URLs, and use a callback function called with the response downloaded from those requests. In the callback function, you parse the response (web page) and return a %Crawly.ParsedItem{} struct. This struct should contain new requests to follow and items to be stored. In the callback functions, you parse the page contents, typically using Floki (but you can also use any other library you prefer) and generate items with the parsed data. Spiders are executed in the context of Crawly.Worker processes, and you can control the amount of concurrent workers via concurrent_requests_per_domain setting. All requests are being processed sequentially and are pre-processed by Middlewares. All items are processed sequentially and are processed by Item pipelines. Behaviour functions In order to make a working web crawler, all the behaviour callbacks need to be implemented. init() - a part of the Crawly.Spider behaviour. This function should return a KVList which contains a start_urls entry with a list, which defines the starting requests made by Crawly. base_url() - defines a base_url of the given Spider. This function is used in order to filter out all requests which are going outside of the crawled website. parse_item(response) - a function which defines how a given response is translated into the Crawly.ParsedItem structure. On the high level this function defines the extraction rules for both Items and Requests."},{"ref":"basic_concepts.html#requests-and-responses","title":"Basic Concepts - Requests and Responses","type":"extras","doc":"Crawly uses Request and Response objects for crawling web sites. Typically, Request objects are generated in the spiders and pass across the system until they reach the Crawly.Worker process, which executes the request and returns a Response object which travels back to the spider that issued the request. The Request objects are being modified by the selected Middlewares, before hitting the worker. The request is defined as the following structure: @type t :: %Crawly.Request{ url: binary(), headers: [header()], prev_response: %{}, options: [option()] } @type header() :: {key(), value()} Where: url - is the url of the request headers - define http headers which are going to be used with the given request options - would define options (like follow redirects). Crawly uses HTTPoison library to perform the requests, but we have plans to extend the support with other pluggable backends like selenium and others. Responses are defined in the same way as HTTPoison responses. See more details here: https://hexdocs.pm/httpoison/HTTPoison.Response.html#content"},{"ref":"basic_concepts.html#parsed-item","title":"Basic Concepts - Parsed Item","type":"extras","doc":"ParsedItem is a structure which is filled by the parse_item/1 callback of the Spider. The structure is defined in the following way: @type item() :: %{} @type t :: %__MODULE__{ items: [item()], requests: [Crawly.Request.t()] } The parsed item is being processed by Crawly.Worker process, which sends all requests to the Crawly.RequestsStorage process, responsible for pre-processing requests and storing them for the future execution, all items are being sent to Crawly.DataStorage process, which is responsible for pre-processing items and storing them on disk. For now only one Storage backend is supported (writing on disc). But in future Crawly will also support work with amazon S3, sql and others."},{"ref":"basic_concepts.html#the-crawly-pipeline-behaviour","title":"Basic Concepts - The Crawly.Pipeline Behaviour.","type":"extras","doc":"Crawly is using a concept of pipelines when it comes to processing of the elements sent to the system. This is applied to both request and scraped item manipulation. Conceptually, requests go through a series of manipulations, before the response is fetched. The response then goes through another different series of manipulations. Importantly, the way that requests and responses are manipulated are abstracted into the Crawly.Pipeline behaviour. This allows for a modular system for declaring changes. It is also to be noted that Each Crawly.Pipeline module, when declared, are applied sequentially through the Crawly.Utils.pipe/3 function. Writing Tests for Custom Pipelines Modules that implement the Crawly.Pipeline behaviour can make use of the Crawly.Utils.pipe/3 function to test for expected behaviour. Refer to the function documentation for more information and examples."},{"ref":"basic_concepts.html#request-middlewares","title":"Basic Concepts - Request Middlewares","type":"extras","doc":"These are configured under the middlewares option. See configuration for more details. Middleware: A pipeline module that modifies a request. It implements the Crawly.Pipeline behaviour. Middlewares are able to make changes to the underlying request, a Crawly.Request struct. The request, along with any options specified, is then passed to the fetcher (currently HTTPoison). The available configuration options should correspond to the underlying options of the fetcher in use. Note that all request configuration options for HTTPoison, such as proxy, ssl, etc can be configured through Crawly.Request.options. Built-in middlewares: Crawly.Middlewares.DomainFilter - this middleware will disable scheduling for all requests leading outside of the crawled site. Crawly.Middlewares.RobotsTxt - this middleware ensures that Crawly respects the robots.txt defined by the target website. Crawly.Middlewares.UniqueRequest - this middleware ensures that crawly would not schedule the same URL(request) multiple times. Crawly.Middlewares.UserAgent - this middleware is used to set a User Agent HTTP header. Allows to rotate UserAgents, if the last one is defined as a list. Item Pipelines Item Pipelines: a pipeline module that modifies and pre-processes a scraped item. Built-in item pipelines: Crawly.Pipelines.Validate - validates that a given item has all the required fields. All items which don&#39;t have all required fields are dropped. Crawly.Pipelines.DuplicatesFilter - filters out items which are already stored the system. Crawly.Pipelines.JSONEncoder- converts items into JSON format. Crawly.Pipelines.CSVEncoder- converts items into CSV format. Crawly.Pipelines.WriteToFile- Writes information to a given file. The list of item pipelines used with a given project is defined in the project settings."},{"ref":"basic_concepts.html#creating-a-custom-pipeline-module","title":"Basic Concepts - Creating a Custom Pipeline Module","type":"extras","doc":"Both item pipelines and request middlewares follows the Crawly.Pipeline behaviour. As such, when creating your custom pipeline, it will need to implement the required callback c:Crawly.Pipeline.run\\3. The c:Crawly.Pipeline.run\\3 callback receives the processed item, item from the previous pipeline module as the first argument. The second argument, state, is a map containing information such as spider which the item originated from (under the :spider_name key), and may optionally store pipeline information. Finally, opts is a keyword list containing any tuple-based options. Passing Configuration Options To Your Pipeline Tuple-based option declaration is supported, similar to how a GenServer is declared in a supervision tree. This allows for pipeline reusability for different use cases. For example, you can pass options in this way through your pipeline declaration: pipelines: [ {MyCustomPipeline, my_option: &quot;value&quot;} ] In your pipeline, you will then receive the options passed through the opts argument. defmodule MyCustomPipeline do @impl Crawly.Pipeline def run(item, state, opts) do IO.inspect(opts) # shows keyword list of [ my_option: &quot;value&quot; ] # Do something end end Best Practices The use of global configs is discouraged, hence one pass options through a tuple-based pipeline declaration where possible. When storing information in the state map, ensure that the state is namespaced with the pipeline name, so as to avoid key clashing. For example, to store state from MyEctoPipeline, store the state on the key :my_ecto_pipeline_my_state. Item Pipeline Example - Ecto Storage Pipeline defmodule MyApp.MyEctoPipeline do @impl Crawly.Pipeline def run(item, state, _opts \\\\ []) do case MyApp.insert_with_ecto(item) do {:ok, _} -&gt; # insert successful, carry on with pipeline {item, state} {:error, _} -&gt; # insert not successful, drop from pipeline {false, state} end end end Request Middleware Example - Add a Proxy Following the documentation for proxy options of a request in HTTPoison, we can do the following: defmodule MyApp.MyProxyMiddleware do @impl Crawly.Pipeline def run(request, state, opts \\\\ []) do # Set default proxy and proxy_auth to nil opts = Enum.into(opts, %{proxy: nil, proxy_auth: nil}) case opts.proxy do nil -&gt; # do nothing {request, state} value -&gt; old_options = request.options new_options = [proxy: opts.proxy, proxy_auth: opts.proxy_auth] new_request = Map.put(request, :options, old_optoins ++ new_options) {new_request, state} end end end"},{"ref":"configuration.html","title":"Configuration","type":"extras","doc":"Configuration A basic example: config :crawly, pipelines: [ # my pipelines ] middlewares: [ # my middlewares ]"},{"ref":"configuration.html#options","title":"Configuration - Options","type":"extras","doc":"base_store_path :: binary() [DEPRECATED in 0.6.0] default: &quot;/tmp&quot; Defines the path where items are stored in the filesystem. This setting is used by the Crawly.DataStorageWorker process. Deprecated: This has been deprecated in favour of having pipelines to handle data storage, as of 0.6.0 user_agents :: list() default: [&quot;Crawly Bot 1.0&quot;] Defines a user agent string for Crawly requests. This setting is used by the Crawly.Middlewares.UserAgent middleware. When the list has more than one item, all requests will be executed, each with a user agent string chosen randomly from the supplied list. Deprecated: This has been deprecated in favour of tuple-based pipeline configuration instead of global configurations, as of 0.7.0. Refer to Crawly.Middlewares.UserAgent module documentation for correct usage. item :: [atom()] default: [] Defines a list of required fields for the item. When none of the default fields are added to the following item (or if the values of required fields are &quot;&quot; or nil), the item will be dropped. This setting is used by the Crawly.Pipelines.Validate pipeline Deprecated: This has been deprecated in favour of tuple-based pipeline configuration instead of global configurations, as of 0.7.0. Refer to Crawly.Pipelines.Validate module documentation for correct usage. item_id :: atom() default: nil Defines a field which will be used in order to identify if an item is a duplicate or not. In most of the ecommerce websites the desired id field is the SKU. This setting is used in the Crawly.Pipelines.DuplicatesFilter pipeline. If unset, the related middleware is effectively disabled. Deprecated: This has been deprecated in favour of tuple-based pipeline configuration instead of global configurations, as of 0.7.0. Refer to Crawly.Pipelines.DuplicatesFilter module documentation for correct usage. pipelines :: [module()] default: [] Defines a list of pipelines responsible for pre processing all the scraped items. All items not passing any of the pipelines are dropped. If unset, all items are stored without any modifications. Example configuration of item pipelines: config :crawly, pipelines: [ {Crawly.Pipelines.Validate, fields: [:id, :date]}, {Crawly.Pipelines.DuplicatesFilter, item_id: :id}, Crawly.Pipelines.JSONEncoder, {Crawly.Pipelines.WriteToFile, extension: &quot;jl&quot;, folder: &quot;/tmp&quot;} # NEW IN 0.6.0 ] middlewares :: [module()] The default middlewares are as follows: config :crawly, middlewares: [ Crawly.Middlewares.DomainFilter, Crawly.Middlewares.UniqueRequest, Crawly.Middlewares.RobotsTxt, {Crawly.Middlewares.UserAgent, user_agents: [&quot;My Bot&quot;] } ] Defines a list of middlewares responsible for pre-processing requests. If any of the requests from the Crawly.Spider is not passing the middleware, it&#39;s dropped. closespider_itemcount :: pos_integer() default: 5000 An integer which specifies a number of items. If the spider scrapes more than that amount and those items are passed by the item pipeline, the spider will be closed. If set to nil the spider will not be stopped. closespider_timeout :: pos_integer() default: nil Defines a minimal amount of items which needs to be scraped by the spider within the given timeframe (30s). If the limit is not reached by the spider - it will be stopped. follow_redirects :: boolean() default: false Defines is Crawly spider is supposed to follow HTTP redirects or not. concurrent_requests_per_domain :: pos_integer() default: 4 The maximum number of concurrent (ie. simultaneous) requests that will be performed by the Crawly workers. proxy :: binary() Requests can be directed through a proxy. It will set the proxy option for the request. It&#39;s possible to set proxy using the proxy value of Crawly config, for example: config :crawly, proxy: &quot;&lt;proxy_host&gt;:&lt;proxy_port&gt;&quot;,"},{"ref":"http_api.html","title":"HTTP API","type":"extras","doc":"HTTP API Crawly supports a basic HTTP API, which allows to control the Engine behaviour."},{"ref":"http_api.html#starting-a-spider","title":"HTTP API - Starting a spider","type":"extras","doc":"The following command will start a given Crawly spider: curl -v localhost:4001/spiders/&lt;spider_name&gt;/schedule"},{"ref":"http_api.html#stopping-a-spider","title":"HTTP API - Stopping a spider","type":"extras","doc":"The following command will stop a given Crawly spider: curl -v localhost:4001/spiders/&lt;spider_name&gt;/stop"},{"ref":"http_api.html#getting-currently-running-spiders","title":"HTTP API - Getting currently running spiders","type":"extras","doc":"curl -v localhost:4001/spiders"},{"ref":"http_api.html#getting-spider-stats","title":"HTTP API - Getting spider stats","type":"extras","doc":"curl -v localhost:4001/spiders/&lt;spider_name&gt;/scheduled-requests curl -v localhost:4001/spiders/&lt;spider_name&gt;/scraped-items"},{"ref":"ethical_aspects.html","title":"Ethical Crawling","type":"extras","doc":"Ethical Crawling It is important to be polite when performing web crawling. Avoid harming scraped websites. Scraping politely: A polite crawler respects robots.txt. A polite crawler never degrades a website’s performance. A polite crawler identifies its creator with contact information. A polite crawler is not a pain in the buttocks of system administrators."}]